#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QLabel>
#include <QSpinBox>
#include <QPushButton>
#include "cdictionaryinttoint.h"
#include <QTextEdit>
#include <QStatusBar>
#ifdef STRS
#include "cpoint.h"
#endif

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    MainWindow();
    
private slots:
    void onGetButtonClicked();
    void onSetButtonClicked();
    void onRemoveButtonClicked();
    void onFeedButtonClicked();
    void onFindButtonClicked();
    void checkTextEditInput();
    void save();
    void about();
    void clear();
    
private:
    QLabel *keyLabel;
    QLabel *valueLabel;
#ifdef REV
    QTextEdit *keySpinBox;
    QSpinBox *valueSpinBox;
#ifdef STRS
    QSpinBox *valueYSpinBox;
    QSpinBox *valueZSpinBox;
#endif
#else
    QSpinBox *keySpinBox;
    QTextEdit *valueSpinBox;
#endif

    QPushButton *getButton;
    QPushButton *setButton;
    QPushButton *removeButton;
    QPushButton *findButton;
#ifdef REV
#ifdef STRS
    CDictionaryIntToInt<const char*,CPoint> dictionary;
#else
    CDictionaryIntToInt<std::string,int> dictionary;
#endif
#else
CDictionaryIntToInt<int, std::string> dictionary;
#endif
    
    QTextEdit *textEditInput;
    QTextEdit *textEditOutput;
    QPushButton *buttonUnderTextEdit2;
    QStatusBar *statusBar;
    
    std::vector<int> valuesArray;
    
    void animateSpinBox();
    void setupUi();
    void connectSignalsAndSlots();
};

#endif // MAINWINDOW_H
